package interface_graphique;


/*
 * Une tâche envoyée au Thread de Swing
 * 
 * ajoute une ligne de texte dans la fenêtre de tchat.
 */

/**
 * 
 * @author Éric Lallet.
 *
 */
public class AjouterLigne implements Runnable {
	/**
	 * JFrame Swing contenant l'interface graphique.
	 */
	private InterfaceGraphique fenetre;
	/**
	 * ligne de texte à afficher.
	 */
	private String ligne;
	
	/**
	 * passe à faux quand une réponse a été validée. Remis à vrai à la question suivante.
	 */
	private boolean reponsePossible = false;
	/**
	 * Constructeur qui initialise les deux attributs de la classe (fenetre et ligne).
	 * @param fenetre
	 *               JFrame Swing où seront afficher les lignes.
	 * @param ligne
	 *               ligne à afficher.
	 * @param reponsePossible
	 *               possible ou pas de valider une réponse.              
	 */
	public AjouterLigne(final InterfaceGraphique fenetre, final String ligne, final boolean reponsePossible) {
		this.fenetre = fenetre;
		this.ligne = ligne;
	}
	
	/**
	 * méthode qui sera ajoutée aux tâches du Thread de SWING.
	 */
	public void run() {
		this.fenetre.getTexte().ecrireNouveauTexte(this.ligne);
		this.fenetre.setReponsePossible(reponsePossible);
		
	}
	

}
