package trivial;

import static common.Log.LOGGER_NAME_TEST;
import static common.Log.LOG_ON;
import static common.Log.TEST;

import java.io.IOException;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.nio.channels.SocketChannel;

import org.apache.log4j.Level;
import org.junit.Ignore;
import org.junit.Test;

import common.FullDuplexMsgWorker;
import common.Log;

public class TestOpenListenChannel {
	static public final int PORT = 5010;
	static public final String HOST = "localhost";
	static public final String NICK = "Pseudo";
	
	//@Ignore
	@Test
	public void testOpenListenChannel() throws IOException {
		Log.configureALogger(LOGGER_NAME_TEST, Level.TRACE);
		if (LOG_ON && TEST.isInfoEnabled()) {
			TEST.info("starting " + TestId.OPENLISTENCHANNEL);
		}
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing OpenListenChannel:  starting server");
		}
		// creating new server
		TrivialServer trivialServer = new TrivialServer(PORT, AppliServer.TRIVIALHTTPURL, TestId.OPENLISTENCHANNEL);
		
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing OpenListenChannel:  creating ServerSocketChennel");
		}
		// server: open listen channel
		trivialServer.playTest(TestId.OPENLISTENCHANNEL);
		
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing OpenListenChannel:  connecting");
		}
		SocketChannel  rwChan = SocketChannel.open(new InetSocketAddress(InetAddress.getByName(HOST),PORT ));
		
		
		// must be able to send data
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing OpenListenChannel:  test of writting");
		}

		FullDuplexMsgWorker worker = new FullDuplexMsgWorker(rwChan);
		AnswersList answersList = new AnswersList(NICK, 0);
		worker.sendMsg(MessType.ANSWERSLISTTYPE, answersList);
		
		if (LOG_ON && TEST.isInfoEnabled()) {
			TEST.info("end of " + TestId.OPENLISTENCHANNEL);
		}
		
		
	}
	
}
